<%-- src_input_text tag --%>
<%@ tag pageEncoding="UTF-8" body-content="empty"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>
<%@ taglib uri="http://www.jasminesoft.co.jp/jfc" prefix="jfc" %>
<%@ taglib tagdir="/WEB-INF/tags" prefix="tags" %>
<fmt:setBundle basename="jfcapp"/>

<%@ attribute name="value" required="true" type="java.lang.Object" %> <%-- ${TemplateModel_p.FDate} --%>
<%@ attribute name="name" required="true" %> <%-- TemplateModel_p$002ff_date --%>
<%@ attribute name="isOutputFieldClass" type="java.lang.Boolean" %>
<%@ attribute name="fieldClassSuffix" %>
<%@ attribute name="type" required="true" %>
<%@ attribute name="size" %>
<%@ attribute name="maxlength" %>
<%@ attribute name="autocomplete" %>
<%@ attribute name="isReadonly" type="java.lang.Boolean" %>
<%@ attribute name="onchange" %>
<%@ attribute name="onblur" %>
<%@ attribute name="enterKeyAction" %>
<%@ attribute name="checkAcceptFileExt" %>
<%@ attribute name="checkAcceptFileMinSize" %>
<%@ attribute name="checkAcceptFileMaxSize" %>
<%@ attribute name="style" %>
<%@ attribute name="tooltip" %>
<%@ attribute name="placeholder" %>
<%@ attribute name="cursorPosition" %>
<%@ attribute name="multipleFile" type="java.lang.Boolean" %>
<%@ attribute name="fileinputType" %>
<%@ attribute name="fileuploadurl" %>

<%-- __class variable --%>
<c:set var="__class" value=""/>
<c:choose>
<c:when test="${isOutputFieldClass}">
  <c:choose>
  <c:when test="${fn:length(value.errorcode) > 0}">
    <c:set var="__class" value="errorfield${fieldClassSuffix}"/>
  </c:when>
  <c:otherwise>
    <c:set var="__class" value="field${fieldClassSuffix}"/>
  </c:otherwise>
  </c:choose>
</c:when>
<c:otherwise>
  <c:if test="${fn:length(value.errorcode) > 0}">
    <c:set var="__class" value="errorfield_nowidth"/>
  </c:if>
</c:otherwise>
</c:choose>

<c:set var="__style" value=""/>
<c:choose>
  <c:when test="${fn:length(style) > 0}">
    <c:set var="__style" value="${style}"/>
  </c:when>
  <c:otherwise>
  </c:otherwise>
</c:choose>
<c:if test="${fn:length(cursorPosition) > 0}">
  <c:set var="__style" value="${__style};text-align:right;"/>
</c:if>

<%-- onkeydown variable --%>
<c:choose>
<c:when test="${enterKeyAction == 'changetab'}">
<c:set var="onkeydown" value="enterKeyHandler.focusNextElement(this, event);"/>
</c:when>
<c:when test="${enterKeyAction == 'ignore'}">
<c:set var="onkeydown" value="if (event.keyCode == 0x0d) return false;"/>
</c:when>
<c:otherwise>
<c:set var="onkeydown" value="${enterKeyAction}"/>
</c:otherwise>
</c:choose>

<c:choose>
<c:when test="${! empty fileinputType}">
</c:when>
<c:when test="${__jfc_browser_type == 'MSIE10' or  __jfc_browser_type == 'MSIE11' or  __jfc_browser_type == 'Edge' or  __jfc_browser_type == 'Firefox' or  __jfc_browser_type == 'Chrome' or __jfc_browser_type == 'Safari' or __jfc_browser_type == 'MobileSafari'}">
<c:set var="fileinputType" value="new"/>
</c:when>
<c:otherwise>
<c:set var="fileinputType" value="old"/>
</c:otherwise>
</c:choose>

<c:choose>
<c:when test="${fileinputType == 'old'}">

<c:set var="enabled_checkAcceptFileExt"
    value="${fn:length(checkAcceptFileExt) > 0}"/>
<c:if test="${enabled_checkAcceptFileExt}">
  <c:set var="onchange">${onchange};checkAcceptFileExt_${name}(this)</c:set>
</c:if>

<c:if test="${!isReadonly}">
<input type="file" id="${name}" name="${name}"
  <c:if test="${fn:length(size) > 0}"> size="${size}"</c:if>
  <c:if test="${fn:length(__class) > 0}"> class="${__class}"</c:if>
  <c:if test="${fn:length(maxlength) > 0}"> maxlength="${maxlength}"</c:if>
  <c:if test="${fn:length(autocomplete) > 0}"> autocomplete="${autocomplete}"</c:if>
  <%--<c:if test="${isReadonly}"> readonly="readonly"</c:if>--%>
  <c:if test="${fn:length(__style) > 0}"> style="${__style}"</c:if>
<c:if test="${fn:length(onchange) > 0}"> onchange="${onchange}"</c:if>
<c:if test="${fn:length(onkeydown) > 0}"> onKeyDown="${onkeydown}"</c:if>
<c:if test="${fn:length(onblur) > 0}"> onBlur="${onblur}"</c:if>
<c:if test="${fn:length(onfocus) > 0}"> onFocus="${onfocus}"</c:if>
<c:if test="${fn:length(tooltip) > 0}"> title="<fmt:message key='${tooltip}'/>"</c:if>
<c:if test="${fn:length(placeholder) > 0}"> placeholder="<fmt:message key='${placeholder}'/>"</c:if>
<c:if test="${multipleFile}"> multiple="multiple"</c:if>
/> <%-- input --%>
</c:if>

<%-- use JavaScript null check --%>
<input type="hidden" name="${name}_jshselectedfile" value="${fn:escapeXml(value.content)}"/>
<input type="hidden" id="${name}_jshclear" name="${name}_jshclear" value=""/>
<c:if test="${!isReadonly}">
<button id="btnClear_${name}_jshclear_submit" data-dojo-type="wagby/Button" type="button" name="btnClear_${name}_jshclear_submit" onclick="this.valueNode.form.${name}_jshclear.value='aaa';setScrollPosition(this.id);doSubmitForm(this.valueNode.form, '', true);"><fmt:message key="__jfc_common.input_text.clear"/></button>
</c:if>

<c:if test="${enabled_checkAcceptFileExt}">
  <tags:src_input_checkAcceptFileExt
      name="${name}"
      checkAcceptFileExt="${checkAcceptFileExt}"/>
</c:if>

</c:when> <%-- ${fileinputType == 'old'} --%>
<c:otherwise> <%-- ${fileinputType == 'old'} --%>

<script type="text/javascript">

<c:choose>
<c:when test="${fn:length(checkAcceptFileExt) > 0}">
  <c:set var="acceptfileext">${checkAcceptFileExt}</c:set>
</c:when>
<c:otherwise>
  <c:set var="acceptfileext"></c:set>
</c:otherwise>
</c:choose>

<fmt:parseNumber var="acceptFileMinSize" value="${checkAcceptFileMinSize}" integerOnly="true"/>
<c:if test="${empty acceptFileMinSize or acceptFileMinSize <= 0}">
  <c:set var="acceptFileMinSize" value="0" />
</c:if>

<fmt:parseNumber var="acceptFileMaxSize" value="${checkAcceptFileMaxSize}" integerOnly="true"/>
<c:if test="${empty acceptFileMaxSize or acceptFileMaxSize <= 0}">
  <c:set var="acceptFileMaxSize" value="0" />
</c:if>

<c:if test="${empty src_input_text_first_flag}">
var parser_parse_param = [];
require([
  "dijit/registry",
  "dojo/_base/array",
  "dojo/_base/lang",
  "dojo/dom",
  "dojo/dom-style",
  "dojo/query",
  "dojox/form/Uploader",
  "dojox/form/uploader/FileList",
  "dojo/ready"
], function(registry, array, lang, dom, domStyle, query, Uploader, FileList, ready) {

  function supportMultiple() {
    var el = document.createElement("input");
    return ("multiple" in el);
  }

  function checkAcceptFileExt(filename, acceptfileext) {
    var ary = acceptfileext.split(',');
    for (i=0; i<ary.length ;i++) {
        var fileext = ary[i];
        if (filename.match(new RegExp("\."+fileext+"$","i"))) {
            return true;
        }
    }
    return false;
  }

  function getForm() {
    var forms = query('form');
    for (var i=0,l=forms.length; i<l; i++) {
      var form = forms[i];
      if (form.action &&
          (form.id.lastIndexOf('insert', 0) === 0 ||
           form.id.lastIndexOf('update', 0) === 0 ||
           form.id.lastIndexOf('copy', 0) === 0 ||
           form.id.lastIndexOf('showList', 0) === 0)) {
        return form;
      }
    }
    return null;
  }

  function getUrl(name) {
<c:choose>
<c:when test="${fileuploadurl != ''}">
    return "${fileuploadurl}";
</c:when>
<c:otherwise>
    var form = dom.byId(name).form || getForm();
    if (form) {
      return form.action;
    }
</c:otherwise>
</c:choose>
  }

  function parse_src_input_text_file(params) {
    var name = params["name"];
    var multiple = params["multiple"];
    var acceptfileext = params["acceptfileext"];
    var acceptfileminsize = params["acceptfileminsize"];
    var acceptfilemaxsize = params["acceptfilemaxsize"];
    var label;
    if (multiple) {
        label = res.BUTTON_FILE_MULTIPLE;
    } else {
        label = res.BUTTON_FILE_SINGLE;
    }
    var uploader = new dojox.form.Uploader({
      name: name, 
      label: label,
      multiple: multiple, 
      url: getUrl(name),
      connectForm: function() {}
    }, name);

    var filelistres = {
      uploader: uploader
    };
    if (browser_locale.lastIndexOf("ja", 0) == 0) {
      filelistres = {
        uploader: uploader,
        headerIndex:"#",
        headerType:"種類",
        headerFilename:"ファイル名",
        headerFilesize:"サイズ",
      };
    }
    var filelist = new dojox.form.uploader.FileList(filelistres);
    var myObject = {
      name: name,
      multiple: multiple,
      acceptfileext: acceptfileext,
      acceptfileminsize: acceptfileminsize,
      acceptfilemaxsize: acceptfilemaxsize,
      uploader: uploader,
      filelist: filelist,
      onChangeError: true,
      iscomplete: true,
      onChange: function(fileArray) {
        this.onChangeError = false;
        if (! this.multiple && fileArray.length > 1) {
          this.onChangeError = true;
          alert(res.ERROR_MSG_SOME_FILES);
        }
        if (!this.onChangeError) {
          array.forEach(fileArray, function(f, i) {
            if (! checkAcceptFileExt(f.name, this.acceptfileext)) {
              this.onChangeError = true;
                alert('<fmt:message key="__jfc_common.input_file.check.fileextension"/>' + "(" + this.acceptfileext + ")");
                return false;
              }
              if (this.acceptfileminsize > 0 && f.size < this.acceptfileminsize) {
                this.onChangeError = true;
                alert(res.ERROR_CHECK_FILEMINSIZE + "(" + this.acceptfileminsize + ")");
                return false;
              }
              if (this.acceptfilemaxsize > 0 && f.size > this.acceptfilemaxsize) {
                this.onChangeError = true;
                alert(res.ERROR_CHECK_FILEMAXSIZE + "(" + this.acceptfilemaxsize+ ")");
                return false;
              }
	      }, this);
        }
        if (this.onChangeError) {
          domStyle.set(dom.byId(this.name+"_files"), "display", "none");
          this.uploader.reset();
          return;
        }
        domStyle.set(dom.byId(this.name+"_files"), "display", "block");
        this.iscomplete = false;
        this.uploader.upload({"action_FileUpload": ""});
      },
      onComplete: function(fileArray) {
        array.forEach(fileArray, function(f, i) {
		  this._addRow(i+1, this.getFileType(f.name), f.name, f.size);
		}, filelist)
        this.iscomplete = true;
      },
      doSubmit: function(evt) {
        if (! this.iscomplete) {
          alert(res.ERROR_SAVE_LATER);
          throw res.ERROR_SAVE_LATER;
        }
      },
      doClear: function() {
        dom.byId(this.name+"_jshclear").value='aaa';
        setScrollPosition(this.name + "_jshclear");
        doSubmitForm(dom.byId(this.name + "_jshclear").form, '', true);
      },
      onError: function(evt) {
        if (evt.response.status == 401) {
          // Unauthorized
          alert(res.ERROR_UNAUTHORIZED_FILEUPLOAD);
          window.location.href = "logon.do";
          return;
        }
        if (evt.response.text === "") {
          alert(res.ERROR_UNKNWON_FILEUPLOAD);
          return;
        }
        try {
          var ret = JSON.parse(evt.response.text);
          if (ret.message !== "" && ret.message !== undefined) {
            alert(ret.message)
          } else {
            alert(res.ERROR_UNKNWON_FILEUPLOAD);
          }
        } catch(e) {
          alert(res.ERROR_UNKNWON_FILEUPLOAD);
        }
      }
    }
	uploader.on("Change", lang.hitch(myObject, "onChange"));
    uploader.on("Complete", lang.hitch(myObject, "onComplete"));
    uploader.on("Error", lang.hitch(myObject, "onError"));
    addDoSubmit(lang.hitch(myObject, "doSubmit"));
    uploader.startup();

	registry.byId("btnClear_"+name+"_jshclear_submit").on("click", lang.hitch(myObject, "doClear"));
    domStyle.set(dom.byId(name+'_files'), "display", "none");
    dom.byId(name+'_files').appendChild(filelist.domNode);

    // set dropTarget
    var dropTarget = dom.byId(name + '_dropTarget');
    uploader.addDropTarget(dropTarget); 
  }

  ready(function() {
    if (! supportMultiple()) {
      alert("This browser is not supported multiple file upload!!");
    }
    var funcid;
    for (funcid in parser_parse_param) {
      parse_src_input_text_file(parser_parse_param[funcid]);
    }
  });
});

<c:set var="src_input_text_first_flag" value="false" scope="request"/>

</c:if>
parser_parse_param.push({name: '${name}', multiple: ${multipleFile}, acceptfileext: '${acceptfileext}', acceptfileminsize: ${acceptFileMinSize}, acceptfilemaxsize: ${acceptFileMaxSize}});
</script>

<div id="${name}_dropTarget" style="width: 99%;">
<input class="browseButton" id="${name}"/>
<input type="hidden" name="${name}_jshselectedfile" value="${fn:escapeXml(value.content)}"/>
<input type="hidden" id="${name}_jshclear" name="${name}_jshclear" value=""/>
<c:if test="${!isReadonly}">
<button id="btnClear_${name}_jshclear_submit" data-dojo-type="dijit.form.Button" type="button" name="btnClear_${name}_jshclear_submit"><fmt:message key="__jfc_common.input_text.clear"/></button>
<div id="${name}_files"></div>
</div>
</c:if>

</c:otherwise> <%-- ${fileinputType == 'old'} --%>
</c:choose>

